/// <reference path="../../src/types/weiwudi.d.ts" />
import { XYZ } from "ol/source";
import { Coordinate } from "ol/coordinate";
declare const HistMap_base: (abstract new (...args: any[]) => {
    weiwudi?: import("weiwudi").default | undefined;
    _map?: import("../map_ex").MaplatMap | undefined;
    homePosition?: Coordinate | undefined;
    mercZoom?: number | undefined;
    pois: any;
    officialTitle: string;
    title: string;
    mapID: string;
    label: string;
    initialWait?: Promise<any> | undefined;
    maxZoom?: number | undefined;
    minZoom?: number | undefined;
    envelope?: import("@turf/helpers").Feature<import("@turf/helpers").Polygon, import("@turf/helpers").Properties> | undefined;
    centroid?: number[] | undefined;
    insideCheckSysCoord(sysCoord: Coordinate): boolean;
    getCacheEnable(): boolean;
    getTileCacheStatsAsync(): Promise<{
        size?: number | undefined;
        count?: number | undefined;
        total?: number | undefined;
        percent?: number | undefined;
    }>;
    getTileCacheSizeAsync(): Promise<number>;
    fetchAllTileCacheAsync(callback: any): Promise<void>;
    cancelTileCacheAsync(): Promise<void>;
    clearTileCacheAsync(): Promise<void>;
    getMap(): import("../map_ex").MaplatMap | undefined;
    setViewpointRadian(cond: {
        x?: number | undefined;
        y?: number | undefined;
        latitude?: number | undefined;
        longitude?: number | undefined;
        mercZoom?: number | undefined;
        zoom?: number | undefined;
        direction?: number | undefined;
        rotation?: number | undefined;
    }): void;
    setViewpoint(cond: {
        x?: number | undefined;
        y?: number | undefined;
        latitude?: number | undefined;
        longitude?: number | undefined;
        mercZoom?: number | undefined;
        zoom?: number | undefined;
        direction?: number | undefined;
        rotation?: number | undefined;
    }): void;
    goHome(): void;
    setGPSMarkerAsync(position: any, ignoreMove?: boolean): Promise<unknown>;
    setGPSMarker(position: any, ignoreMove?: boolean): void;
    mercsFromGPSValue(lnglat: Coordinate, acc: number): number[][];
    rotateMatrix(xys: number[][], theta?: number | undefined): Coordinate[];
    resolvePois(pois?: any): Promise<void>;
    getPoi(id: string): undefined;
    addPoi(data: any, clusterId?: string | undefined): any;
    removePoi(id: string): void;
    clearPoi(clusterId?: string | undefined): void;
    listPoiLayers(hideOnly?: boolean, nonzero?: boolean): any[];
    getPoiLayer(id: string): any;
    addPoiLayer(id: string, data: any): void;
    removePoiLayer(id: string): void;
    merc2XyAsync(merc: Coordinate): Promise<Coordinate>;
    merc2XyAsync_ignoreBackground(merc: Coordinate): Promise<void | Coordinate>;
    xy2MercAsync(xy: Coordinate): Promise<Coordinate>;
    xy2SysCoord(xy: Coordinate): Coordinate;
    sysCoord2Xy(sysCoord: Coordinate): Coordinate;
    viewpoint2MercsAsync(viewpoint?: import("./mixin").ViewpointArray | undefined, size?: import("ol/size").Size | undefined): Promise<import("./mixin").CrossCoordinatesArray>;
    mercs2ViewpointAsync(mercs: import("./mixin").CrossCoordinatesArray): Promise<import("./mixin").ViewpointArray>;
    mercs2SysCoordsAsync_multiLayer(mercs: import("./mixin").CrossCoordinatesArray): Promise<(import("./mixin").CrossCoordinatesArray | undefined)[]>;
    merc2SysCoordAsync_ignoreBackground(merc: Coordinate): Promise<void | Coordinate>;
    merc2SysCoordAsync(merc: Coordinate): Promise<Coordinate>;
    sysCoord2MercAsync(sysCoord: Coordinate): Promise<Coordinate>;
    zoom2Radius(size: import("ol/size").Size, zoom?: number | undefined): number;
    viewpoint2SysCoords(viewpoint?: import("./mixin").ViewpointArray | undefined, size?: import("ol/size").Size | undefined): import("./mixin").CrossCoordinatesArray;
    mercViewpoint2Mercs(viewpoint?: import("./mixin").ViewpointArray | undefined, size?: import("ol/size").Size | undefined): import("./mixin").CrossCoordinatesArray;
    sysCoords2Viewpoint(sysCoords: import("./mixin").CrossCoordinatesArray): import("./mixin").ViewpointArray;
    mercs2MercViewpoint(mercs: import("./mixin").CrossCoordinatesArray): import("./mixin").ViewpointArray;
    sysCoords2Xys(sysCoords: import("./mixin").CrossCoordinatesArray): import("./mixin").CrossCoordinatesArray;
    xys2SysCoords(xys: import("./mixin").CrossCoordinatesArray): import("./mixin").CrossCoordinatesArray;
    mercs2XysAsync(mercs: import("./mixin").CrossCoordinatesArray): Promise<import("./mixin").CrossCoordinatesArray>;
    xys2MercsAsync(xys: import("./mixin").CrossCoordinatesArray): Promise<import("./mixin").CrossCoordinatesArray>;
}) & typeof XYZ;
export declare abstract class HistMap extends HistMap_base {
    width: number;
    height: number;
    _maxxy: number;
    constructor(options?: any);
    insideCheckXy(xy: Coordinate): boolean;
    insideCheckSysCoord(sysCoord: Coordinate): boolean;
    modulateXyInside(xy: any): number[];
    modulateSysCoordInside(histCoords: any): Coordinate;
    xy2SysCoord(xy: Coordinate): Coordinate;
    sysCoord2Xy(sysCoord: Coordinate): Coordinate;
}
export {};
